#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
const int N=5e5+5,M=1e6+5,mod=1e9+7;
int head[N],to[M<<1],nxt[M<<1],tot;
int n,m,dfn[N],low[N],cnt,sz;
ll ans;
stack<int> s;
bool instack[N],flag;
inline void add(int x,int y)
{
    nxt[++tot]=head[x];
    head[x]=tot;
    to[tot]=y;
}
ll qpow(ll x,ll y)
{
    ll cnt=1;
    while(y)
    {
        if(y&1) cnt=cnt*x%mod;
        x=x*x%mod;
        y>>=1;
    }
    return cnt;
}
void tarjan(int u)
{
    dfn[u]=low[u]=++cnt;
    s.push(u);
    instack[u]=1;
    for(int i=head[u];i;i=nxt[i])
    {
        int v=to[i];
        if(!dfn[v])
        {
            tarjan(v);
            low[u]=min(low[u],low[v]);
        }
        else if(instack[v])
            low[u]=min(low[u],dfn[v]);
    }
    if(low[u]==dfn[u])
    {
        int x=0;
        sz=0;
        while(x!=u)
        {
            x=s.top();
            s.pop();
            sz++;
        }
        if(sz>1) flag=1;
    }
    return;
}
int main()
{
    freopen("barrack.in","r",stdin);
    freopen("barrack.out","w",stdout);
    scanf("%d%d",&n,&m);
    int cnt=0;
    for(int i=1,x,y;i<=m;i++)
    {
        scanf("%d%d",&x,&y);
        add(x,y),add(y,x);
        if((x==i&&y==i+1)||(x==i+1&&y==i)) cnt++;
    }
    if(m==n-1)
    {
        ans=n*qpow(2,m)%mod;
        for(int len=1;len<=m;len++)
        {
            ans=(ans+qpow(2,m-len)*qpow(2,len-1)*(m-len+1)%mod)%mod;
        }
        cout<<ans;
    }
    if(m==n)
    {
        for(int i=1;i<=n;i++)
            if(!dfn[i]&&!flag)
                tarjan(i);
    }
    return 0;
}